﻿XIncludeFile"GMP.pbi"
; Structure mpf_struct
;     _mp_prec.l
;     _mp_size.l
;     _mp_exp.l
;     _mp_d.l
; EndStructure
; 
; 
; ImportC "gmp.lib"
;    mpf_init2(var.l,prec.l) As "___gmpf_init2"
;    mpf_set_str(var.l,s$,num.l) As "___gmpf_init_set_str"
;    mpf_sqrt(a.l,b.l) As "___gmpf_sqrt"
;    mpf_ui_div(v_b.l, b1.l, v_c.l) As "___gmpf_ui_div"
;    mpf_add(A.l, sa.l, sb.l) As "___gmpf_add"
;    mpf_div_ui(A0.l,A1.l, d.l) As "___gmpf_div_ui"
;    mpf_mul(B.l,va.l,vb.l) As "___gmpf_mul"
;    mpf_sub(T.l,va.l,A.l) As "___gmpf_sub"
;    mpf_pow_ui(T0.l,T1.l,p.l) As "___gmpf_pow_ui"
;    mpf_mul_ui(Pb.l,ps.l, n.l) As "___gmpf_mul_ui"
;    mpf_swap(sa.l,BA.l) As "___gmpf_swap"
;    mpf_div(d.l, d1.l, d2.l) As "___gmpf_div"
;    mp_sprintf(*buf, fmt$,va.l) As "___gmp_sprintf"
;    mpf_clear( va.l ) As "___gmpf_clear"
; EndImport

PI_DIGITS=1000;00000
LOG2_10.f=3.321928094887362
PRECISION=PI_DIGITS*LOG2_10

;Dim As __mpf_struct a,b,t,p,aa,bb,tt,pp,pi
a.mpf;_struct
b.mpf;_struct
t.mpf;_struct
p.mpf;_struct
aa.mpf;_struct
bb.mpf;_struct
tt.mpf;_struct
pp.mpf;_struct
pi.mpf;_struct

mpf_init2( @a, PRECISION )
mpf_init2( @b, PRECISION )
mpf_init2( @t, PRECISION )
mpf_init2( @p, PRECISION )
mpf_init2( @aa, PRECISION )
mpf_init2( @bb, PRECISION )
mpf_init2( @tt, PRECISION )
mpf_init2( @pp, PRECISION )
mpf_init2( @pi, PRECISION )

mpf_set_str( @a, "1.0", 10 )
mpf_set_str( @b, "0.5", 10 )
mpf_set_str( @t, "0.25", 10 )
mpf_set_str( @p, "1.0", 10 )
mpf_sqrt( @b, @b )

For i = 1 To Int(Log(PI_DIGITS)*1.44269504088896)

;     ''--------------
;     '' aa = (a+b)/2
;     ''--------------

    mpf_add( @aa,  @a,  @b )
    mpf_div_ui( @aa, @aa , 2 )

;     ''----------------
;     '' bb = sqrt(a*b)
;     ''----------------

    mpf_mul( @bb, @a, @b )
    mpf_sqrt( @bb, @bb )

;     ''-------------------
;     '' tt = t-p*(a-aa)^2
;     ''-------------------

    mpf_sub( @tt, @a, @aa )
    mpf_pow_ui( @tt, @tt, 2 )
    ;'mpf_mul( @tt, @tt, @tt )
    mpf_mul( @tt, @tt, @p )
    mpf_sub( @tt, @t, @tt )

;     ''----------
;     '' pp = 2*p
;     ''----------

    mpf_mul_ui( @pp, @p, 2 )

;     ''--------------------------------
;     '' a = aa, b = bb, t = tt, p = pp
;     ''--------------------------------

    mpf_swap( @a, @aa )
    mpf_swap( @b, @bb )
    mpf_swap( @t, @tt )
    mpf_swap( @p, @pp )

Next i

; ''-------------------
; '' pi ~= (a+b)^2/4*t
; ''-------------------

mpf_add( @pi, @a, @b )
mpf_pow_ui( @pi, @pi, 2 )
mpf_div_ui( @pi, @pi, 4 )
mpf_div( @pi, @pi, @t )

;t2 = timer
;Dim As zstring ptr pie=allocate(PI_DIGITS+10)
*m=AllocateMemory((PI_DIGITS+10))
f$="%."+Str(PI_DIGITS)+"Ff"
gmp_sprintf(*m, @f$, @pi)

; open "pi_100_million.txt" For output As 1
; print #1,*pie
; close 1
; print "pi written to the file pi_100_million.txt"
; print t2-t1; " seconds"
; print "gmp version ";*gmp_version
Debug PeekS(*m,-1,#PB_Ascii)
FreeMemory(*m)

mpf_clear( @pi )
mpf_clear( @pp )
mpf_clear( @tt )
mpf_clear( @bb )
mpf_clear( @aa )
mpf_clear( @p )
mpf_clear( @t )
mpf_clear( @b )
mpf_clear( @a )

;deallocate(pie)

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 113
; FirstLine = 97
; EnableXP